var spaceText = "  ";
var lineBreak = "\n";

function getInputTSV(){
    return $('#inputTextArea').val();
}

function buildXMLText(arr){
    var tags = arr[0];
    var xmlTexts = [];
    if(arr.length <= 1){
        return "";
    }
    xmlTexts.push( '<?xml version="1.0" encoding="utf-8"?>' + lineBreak );
    xmlTexts.push( "<root>" + lineBreak );
    for(var i = 1; i < arr.length; i++){
        var data = arr[i];
        xmlTexts.push( spaceText + "<row>" + lineBreak );
        data.map(function(datum, index){
            var tag = tags[index];
            xmlTexts.push( spaceText + spaceText + "<" + tag + ">" + datum + "</" + tag + ">" + lineBreak );
        });
        xmlTexts.push( spaceText + "</row>" + lineBreak );
    }
    xmlTexts.push( "</root>" + lineBreak );
    return xmlTexts.join('');
}

function convertTSV(){
    var input = getInputTSV();
    var rows = input.split('\n');
    rows = rows.map(function(row){
        return row.split('\t');
    });
    var xmlText = buildXMLText(rows);
    $('#outputTextArea').val(xmlText);
}

//https://stackoverflow.com/questions/3665115/create-a-file-in-memory-for-user-to-download-not-through-server
function downloadXMLFile(text, filename){
    var id = 'donwloadLink';
    var sharpId = '#' + id;
    $(sharpId).remove();

    $('body').append('<a id="' + id + '"></a>');
    var $link = $(sharpId)
        .attr('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text))
        .attr('download', filename);
    $link.get(0).click();
}

function main(){
    $('#convertButton').click(function(){
        convertTSV();
    });

    $('#toClipboardButton').click(function(){
        $('#outputTextArea').select();
        document.execCommand("copy");
    });

    $('#downloadButton').click(function(){
        var outputText = $('#outputTextArea').val();
        var filename = $('#outputFilename').val();
        downloadXMLFile(outputText, filename);
    });
}

$(function(){
    main();
});